% Processo
A=[0 1 0;0 4 0;2 0 2];B=[0;1;0];
C=[0 0 -1];

% Esosistema
S=[0 4; -4 0];


P=[0 0;0 0; 0 0];
Q=[1 0];

% Dimensioni 
n=max(size(A));
ns=max(size(S));

%calcolo dei guadagni per il sistema e per l'osservatore
K=acker(A,-B,[-4 -4 -4])

disp('Autovalori del sistema:')
eig(A+B*K)'


Ao=[A P; zeros(ns,n) S];
Co=[C Q];
Obs=[Co; Co*Ao ; Co*Ao^2; Co*Ao^3; Co*Ao^4 ];
if det(Obs)==0
    disp('Manca l''osservabilit')
    return
end



G=acker([A P; zeros(ns,n) S]',[C Q]',[-2 -2 -2 -2 -2]*2)'


disp('Autovalori dell''osservatore:')
eig([A P; zeros(ns,n) S]-G*[C Q])


%Soulzione con il Maple delle equazioni del regolatore
Pigreco=[-1 2; -8 -4; 1 0];
Gamma=[48 -16];


%Soulzione semplificata delle equazioni del regolatore
%X=inv([A B; C 0])*[-P;-Q]
%Pigreco=X(1:2,:);
%Gamma=X(3,:);



% Calcolo del compensatore
H=[K Gamma-K*Pigreco];
F=[A P;  zeros(ns,n) S]+[B;zeros(ns,1)]*H-G*[C Q];

% Autovalori del ciclo chiuso
disp('Autovalori del ciclo chiuso:')
eig([A B*H; G*C F])

%Verifica
Sigma=[Pigreco;eye(ns)]

if sum(sum(abs(Sigma*S-F*Sigma)))>1e-10
    disp('Equazioni di Francis non corrette!')
    Sigma*S-F*Sigma
    return
end


% Sumulazione del sistema complessivo
Ac=[ [A B*H; G*C F] [P; G*Q]; zeros(ns,2*n+ns)  S];
Bc=zeros(2*n+2*ns,1);
Cc=[C zeros(1,n+ns) Q];

Cy=[-C zeros(1,n+ns) [0 0]];
Crif=[zeros(1,n) zeros(1,n+ns) [1 0]];


Dc=0;

SYS = ss(Ac,Bc,Cc,Dc);
max_t_sim=30;
t_sim=[0:0.01:max_t_sim]';
u_sim=zeros(max_t_sim/0.01+1,1);


[Y,T,X] = lsim(SYS,u_sim,t_sim,[ 0 0 0 0 0 0 0 0 1 0]);

figure(1)
subplot(311)
plot(T,Y)
grid

subplot(312)
plot(T,[(Cy*X')'  (Crif*X')'])
grid


subplot(313)
plot(T,X(:,1:10))
grid


